package com.sun.rowset;

import java.sql.NClob;
import java.sql.RowId;
import java.sql.SQLFeatureNotSupportedException;
import java.sql.SQLXML;
import javax.sql.RowSetEvent;
import java.sql.Savepoint;
import java.net.URL;
import javax.sql.rowset.serial.SerialRef;
import java.util.Arrays;
import javax.sql.RowSetMetaData;
import java.util.Calendar;
import java.sql.Ref;
import java.sql.Statement;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.io.Reader;
import javax.sql.rowset.serial.SQLInputImpl;
import sun.reflect.misc.ReflectUtil;
import java.io.StringBufferInputStream;
import java.io.UnsupportedEncodingException;
import java.io.InputStream;
import java.sql.Time;
import java.text.ParseException;
import java.text.DateFormat;
import java.sql.Timestamp;
import java.sql.Date;
import java.math.BigDecimal;
import com.sun.rowset.internal.BaseRow;
import java.util.TreeMap;
import java.util.Collection;
import java.io.OptionalDataException;
import java.io.StreamCorruptedException;
import java.io.ObjectInputStream;
import java.io.ByteArrayInputStream;
import java.text.MessageFormat;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.util.Iterator;
import javax.sql.rowset.spi.SyncProviderException;
import com.sun.rowset.internal.CachedRowSetWriter;
import java.util.Map;
import javax.sql.rowset.serial.SerialStruct;
import javax.sql.rowset.serial.SerialBlob;
import javax.sql.rowset.serial.SerialClob;
import javax.sql.rowset.serial.SerialArray;
import java.sql.Array;
import java.sql.Clob;
import java.sql.Blob;
import java.sql.SQLData;
import java.sql.Struct;
import com.sun.rowset.internal.Row;
import java.util.Hashtable;
import java.sql.SQLException;
import com.sun.rowset.providers.RIOptimisticProvider;
import javax.sql.rowset.spi.SyncFactory;
import java.io.IOException;
import javax.sql.rowset.spi.TransactionalWriter;
import com.sun.rowset.internal.CachedRowSetReader;
import java.sql.ResultSet;
import javax.sql.rowset.RowSetWarning;
import java.sql.SQLWarning;
import com.sun.rowset.internal.InsertRow;
import java.util.Vector;
import javax.sql.rowset.RowSetMetaDataImpl;
import java.sql.ResultSetMetaData;
import java.sql.Connection;
import javax.sql.RowSetWriter;
import javax.sql.RowSetReader;
import javax.sql.rowset.spi.SyncProvider;
import javax.sql.rowset.CachedRowSet;
import java.io.Serializable;
import javax.sql.RowSetInternal;
import javax.sql.RowSet;
import javax.sql.rowset.BaseRowSet;

public class CachedRowSetImpl extends BaseRowSet implements RowSet, RowSetInternal, Serializable, Cloneable, CachedRowSet
{
    private SyncProvider provider;
    private RowSetReader rowSetReader;
    private RowSetWriter rowSetWriter;
    private transient Connection conn;
    private transient ResultSetMetaData RSMD;
    private RowSetMetaDataImpl RowSetMD;
    private int[] keyCols;
    private String tableName;
    private Vector<Object> rvh;
    private int cursorPos;
    private int absolutePos;
    private int numDeleted;
    private int numRows;
    private InsertRow insertRow;
    private boolean onInsertRow;
    private int currentRow;
    private boolean lastValueNull;
    private SQLWarning sqlwarn;
    private String strMatchColumn;
    private int iMatchColumn;
    private RowSetWarning rowsetWarning;
    private String DEFAULT_SYNC_PROVIDER;
    private boolean dbmslocatorsUpdateCopy;
    private transient ResultSet resultSet;
    private int endPos;
    private int prevEndPos;
    private int startPos;
    private int startPrev;
    private int pageSize;
    private int maxRowsreached;
    private boolean pagenotend;
    private boolean onFirstPage;
    private boolean onLastPage;
    private int populatecallcount;
    private int totalRows;
    private boolean callWithCon;
    private CachedRowSetReader crsReader;
    private Vector<Integer> iMatchColumns;
    private Vector<String> strMatchColumns;
    private boolean tXWriter;
    private TransactionalWriter tWriter;
    protected transient JdbcRowSetResourceBundle resBundle;
    private boolean updateOnInsert;
    static final long serialVersionUID = 1884577171200622428L;
    
    public CachedRowSetImpl() throws SQLException {
        this.strMatchColumn = "";
        this.iMatchColumn = -1;
        this.DEFAULT_SYNC_PROVIDER = "com.sun.rowset.providers.RIOptimisticProvider";
        this.pagenotend = true;
        this.tXWriter = false;
        this.tWriter = null;
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
        this.provider = SyncFactory.getInstance(this.DEFAULT_SYNC_PROVIDER);
        if (!(this.provider instanceof RIOptimisticProvider)) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidp").toString());
        }
        this.rowSetReader = (RowSetReader)this.provider.getRowSetReader();
        this.rowSetWriter = (RowSetWriter)this.provider.getRowSetWriter();
        this.initParams();
        this.initContainer();
        this.initProperties();
        this.onInsertRow = false;
        this.insertRow = null;
        this.sqlwarn = new SQLWarning();
        this.rowsetWarning = new RowSetWarning();
        return;
    }
    
    public CachedRowSetImpl(Hashtable hashtable) throws SQLException {
        this.strMatchColumn = "";
        this.iMatchColumn = -1;
        this.DEFAULT_SYNC_PROVIDER = "com.sun.rowset.providers.RIOptimisticProvider";
        this.pagenotend = true;
        this.tXWriter = false;
        this.tWriter = null;
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
        if (hashtable == null) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.nullhash").toString());
        }
        this.provider = SyncFactory.getInstance((String)hashtable.get("rowset.provider.classname"));
        this.rowSetReader = this.provider.getRowSetReader();
        this.rowSetWriter = this.provider.getRowSetWriter();
        this.initParams();
        this.initContainer();
        this.initProperties();
        return;
    }
    
    private void initContainer() {
        this.rvh = new Vector(100);
        this.cursorPos = 0;
        this.absolutePos = 0;
        this.numRows = 0;
        this.numDeleted = 0;
    }
    
    private void initProperties() throws SQLException {
        if (this.resBundle == null) {
            try {
                this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
            }
            catch (IOException cause) {
                throw new RuntimeException(cause);
            }
        }
        this.setShowDeleted(false);
        this.setQueryTimeout(0);
        this.setMaxRows(0);
        this.setMaxFieldSize(0);
        this.setType(1004);
        this.setConcurrency(1008);
        if (this.rvh.size() > 0 && !this.isReadOnly()) {
            this.setReadOnly(false);
        }
        else {
            this.setReadOnly(true);
        }
        this.setTransactionIsolation(2);
        this.setEscapeProcessing(true);
        this.checkTransactionalWriter();
        this.iMatchColumns = new Vector(10);
        for (int i = 0; i < 10; ++i) {
            this.iMatchColumns.add(i, Integer.valueOf(-1));
        }
        this.strMatchColumns = new Vector(10);
        for (int j = 0; j < 10; ++j) {
            this.strMatchColumns.add(j, null);
        }
    }
    
    private void checkTransactionalWriter() {
        if (this.rowSetWriter != null) {
            Class<Object> class1 = this.rowSetWriter.getClass();
            if (class1 != null) {
                Class[] interfaces = class1.getInterfaces();
                for (int i = 0; i < interfaces.length; ++i) {
                    if (interfaces[i].getName().indexOf("TransactionalWriter") > 0) {
                        this.tXWriter = true;
                        this.establishTransactionalWriter();
                    }
                }
            }
        }
    }
    
    private void establishTransactionalWriter() {
        this.tWriter = (TransactionalWriter)this.provider.getRowSetWriter();
    }
    
    @Override
    public void setCommand(String command) throws SQLException {
        super.setCommand(command);
        if (!this.buildTableName(command).equals("")) {
            this.setTableName(this.buildTableName(command));
        }
    }
    
    @Override
    public void populate(ResultSet resultSet) throws SQLException {
        Map<String, Class<?>> typeMap = this.getTypeMap();
        if (resultSet == null) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.populate").toString());
        }
        this.resultSet = resultSet;
        this.RSMD = resultSet.getMetaData();
        this.initMetaData(this.RowSetMD = new RowSetMetaDataImpl(), this.RSMD);
        this.RSMD = null;
        int columnCount = this.RowSetMD.getColumnCount();
        int maxRows = this.getMaxRows();
        int numRows = 0;
        while (resultSet.next()) {
            Row e = new Row(columnCount);
            if (numRows > maxRows && maxRows > 0) {
                this.rowsetWarning.setNextWarning(new RowSetWarning("Populating rows setting has exceeded max row setting"));
            }
            for (int i = 1; i <= columnCount; ++i) {
                Object val;
                if (typeMap == null || typeMap.isEmpty()) {
                    val = resultSet.getObject(i);
                }
                else {
                    val = resultSet.getObject(i, typeMap);
                }
                if ((val instanceof Struct)) {
                    val = new SerialStruct((Struct)val, typeMap);
                }
                else if ((val instanceof SQLData)) {
                    val = new SerialStruct((SQLData)val, typeMap);
                }
                else if ((val instanceof Blob)) {
                    val = new SerialBlob((Blob)val);
                }
                else if ((val instanceof Clob)) {
                    val = new SerialClob((Clob)val);
                }
                else if ((val instanceof Array)) {
                    if (typeMap != null) {
                        val = new SerialArray((Array)val, typeMap);
                    }
                    else {
                        val = new SerialArray((Array)val);
                    }
                }
                e.initColumnObject(i, val);
            }
            ++numRows;
            this.rvh.add(e);
        }
        this.numRows = numRows;
        this.notifyRowSetChanged();
        return;
    }
    
    private void initMetaData(RowSetMetaDataImpl rowSetMetaDataImpl, ResultSetMetaData resultSetMetaData) throws SQLException {
        int columnCount = resultSetMetaData.getColumnCount();
        rowSetMetaDataImpl.setColumnCount(columnCount);
        for (int i = 1; i <= columnCount; ++i) {
            rowSetMetaDataImpl.setAutoIncrement(i, resultSetMetaData.isAutoIncrement(i));
            if (resultSetMetaData.isAutoIncrement(i)) {
                this.updateOnInsert = true;
            }
            rowSetMetaDataImpl.setCaseSensitive(i, resultSetMetaData.isCaseSensitive(i));
            rowSetMetaDataImpl.setCurrency(i, resultSetMetaData.isCurrency(i));
            rowSetMetaDataImpl.setNullable(i, resultSetMetaData.isNullable(i));
            rowSetMetaDataImpl.setSigned(i, resultSetMetaData.isSigned(i));
            rowSetMetaDataImpl.setSearchable(i, resultSetMetaData.isSearchable(i));
            int columnDisplaySize = resultSetMetaData.getColumnDisplaySize(i);
            if (columnDisplaySize < 0) {
                columnDisplaySize = 0;
            }
            rowSetMetaDataImpl.setColumnDisplaySize(i, columnDisplaySize);
            rowSetMetaDataImpl.setColumnLabel(i, resultSetMetaData.getColumnLabel(i));
            rowSetMetaDataImpl.setColumnName(i, resultSetMetaData.getColumnName(i));
            rowSetMetaDataImpl.setSchemaName(i, resultSetMetaData.getSchemaName(i));
            int precision = resultSetMetaData.getPrecision(i);
            if (precision < 0) {
                precision = 0;
            }
            rowSetMetaDataImpl.setPrecision(i, precision);
            int scale = resultSetMetaData.getScale(i);
            if (scale < 0) {
                scale = 0;
            }
            rowSetMetaDataImpl.setScale(i, scale);
            rowSetMetaDataImpl.setTableName(i, resultSetMetaData.getTableName(i));
            rowSetMetaDataImpl.setCatalogName(i, resultSetMetaData.getCatalogName(i));
            rowSetMetaDataImpl.setColumnType(i, resultSetMetaData.getColumnType(i));
            rowSetMetaDataImpl.setColumnTypeName(i, resultSetMetaData.getColumnTypeName(i));
        }
        if (this.conn != null) {
            this.dbmslocatorsUpdateCopy = this.conn.getMetaData().locatorsUpdateCopy();
        }
    }
    
    @Override
    public void execute(Connection connection) throws SQLException {
        this.setConnection(connection);
        if (this.getPageSize() != 0) {
            (this.crsReader = (CachedRowSetReader)this.provider.getRowSetReader()).setStartPosition(1);
            this.callWithCon = true;
            this.crsReader.readData(this);
        }
        else {
            this.rowSetReader.readData(this);
        }
        this.RowSetMD = (RowSetMetaDataImpl)this.getMetaData();
        if (connection != null) {
            this.dbmslocatorsUpdateCopy = connection.getMetaData().locatorsUpdateCopy();
        }
    }
    
    private void setConnection(Connection conn) {
        this.conn = conn;
    }
    
    @Override
    public void acceptChanges() throws SyncProviderException {
        if (this.onInsertRow) {
            throw new SyncProviderException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidop").toString());
        }
        int cursorPos = this.cursorPos;
        boolean n = false;
        boolean writeData = false;
        try {
            if (this.rowSetWriter != null) {
                int cursorPos2 = this.cursorPos;
                writeData = this.rowSetWriter.writeData(this);
                this.cursorPos = cursorPos2;
            }
            if (this.tXWriter) {
                if (writeData == 0) {
                    (this.tWriter = (TransactionalWriter)this.rowSetWriter).rollback();
                    n = false;
                }
                else {
                    this.tWriter = (TransactionalWriter)this.rowSetWriter;
                    if ((this.tWriter instanceof CachedRowSetWriter)) {
                        ((CachedRowSetWriter)this.tWriter).commit(this, this.updateOnInsert);
                    }
                    else {
                        this.tWriter.commit();
                    }
                    n = true;
                }
            }
            if (n != 0) {
                this.setOriginal();
            }
            else if (n == 0) {
                throw new SyncProviderException(this.resBundle.handleGetObject("cachedrowsetimpl.accfailed").toString());
            }
        }
        catch (SyncProviderException ex) {
            throw ex;
        }
        catch (SQLException ex2) {
            ex2.printStackTrace();
            throw new SyncProviderException(ex2.getMessage());
        }
        catch (SecurityException ex3) {
            throw new SyncProviderException(ex3.getMessage());
        }
        return;
    }
    
    @Override
    public void acceptChanges(Connection connection) throws SyncProviderException {
        this.setConnection(connection);
        this.acceptChanges();
    }
    
    @Override
    public void restoreOriginal() throws SQLException {
        Iterator<Object> iterator = this.rvh.iterator();
        while (iterator.hasNext()) {
            Row row = (Row)iterator.next();
            if (row.getInserted()) {
                iterator.remove();
                --this.numRows;
            }
            else {
                if (row.getDeleted()) {
                    row.clearDeleted();
                }
                if (!row.getUpdated()) {
                    continue;
                }
                row.clearUpdated();
            }
        }
        this.cursorPos = 0;
        this.notifyRowSetChanged();
    }
    
    @Override
    public void release() throws SQLException {
        this.initContainer();
        this.notifyRowSetChanged();
    }
    
    @Override
    public void undoDelete() throws SQLException {
        if (!this.getShowDeleted()) {
            return;
        }
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        Row row = (Row)this.getCurrentRow();
        if (row.getDeleted()) {
            row.clearDeleted();
            --this.numDeleted;
            this.notifyRowChanged();
        }
        return;
    }
    
    @Override
    public void undoInsert() throws SQLException {
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        if (((Row)this.getCurrentRow()).getInserted()) {
            this.rvh.remove(this.cursorPos - 1);
            --this.numRows;
            this.notifyRowChanged();
            return;
        }
        throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.illegalop").toString());
    }
    
    @Override
    public void undoUpdate() throws SQLException {
        this.moveToCurrentRow();
        this.undoDelete();
        this.undoInsert();
    }
    
    @Override
    public RowSet createShared() throws SQLException {
        RowSet set;
        try {
            set = (RowSet)this.clone();
        }
        catch (CloneNotSupportedException ex) {
            throw new SQLException(ex.getMessage());
        }
        return set;
    }
    
    @Override
    protected Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
    
    @Override
    public CachedRowSet createCopy() throws SQLException {
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        try {
            new ObjectOutputStream(out).writeObject(this);
        }
        catch (IOException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.clonefail").toString(), new Object[] { ex.getMessage() }));
        }
        ObjectInputStream objectInputStream;
        try {
            objectInputStream = new ObjectInputStream(new ByteArrayInputStream(out.toByteArray()));
        }
        catch (StreamCorruptedException ex2) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.clonefail").toString(), new Object[] { ex2.getMessage() }));
        }
        catch (IOException ex3) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.clonefail").toString(), new Object[] { ex3.getMessage() }));
        }
        try {
            CachedRowSetImpl cachedRowSetImpl = (CachedRowSetImpl)objectInputStream.readObject();
            cachedRowSetImpl.resBundle = this.resBundle;
            return cachedRowSetImpl;
        }
        catch (ClassNotFoundException ex4) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.clonefail").toString(), new Object[] { ex4.getMessage() }));
        }
        catch (OptionalDataException ex5) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.clonefail").toString(), new Object[] { ex5.getMessage() }));
        }
        catch (IOException ex6) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.clonefail").toString(), new Object[] { ex6.getMessage() }));
        }
    }
    
    @Override
    public CachedRowSet createCopySchema() throws SQLException {
        int numRows = this.numRows;
        this.numRows = 0;
        CachedRowSet copy = this.createCopy();
        this.numRows = numRows;
        return copy;
    }
    
    @Override
    public CachedRowSet createCopyNoConstraints() throws SQLException {
        CachedRowSetImpl cachedRowSetImpl = (CachedRowSetImpl)this.createCopy();
        cachedRowSetImpl.initProperties();
        try {
            cachedRowSetImpl.unsetMatchColumn(cachedRowSetImpl.getMatchColumnIndexes());
        }
        catch (SQLException ex) {}
        try {
            cachedRowSetImpl.unsetMatchColumn(cachedRowSetImpl.getMatchColumnNames());
        }
        catch (SQLException ex2) {}
        return cachedRowSetImpl;
    }
    
    @Override
    public Collection<?> toCollection() throws SQLException {
        TreeMap<Integer, Object> treeMap = new TreeMap();
        for (int i = 0; i < this.numRows; ++i) {
            treeMap.put(Integer.valueOf(i), this.rvh.get(i));
        }
        return treeMap.values();
    }
    
    @Override
    public Collection<?> toCollection(int n) throws SQLException {
        int i = this.numRows;
        Vector<Object> vector = new Vector(i);
        CachedRowSetImpl cachedRowSetImpl = (CachedRowSetImpl)this.createCopy();
        while (i != 0) {
            cachedRowSetImpl.next();
            vector.add(cachedRowSetImpl.getObject(n));
            --i;
        }
        return vector;
    }
    
    @Override
    public Collection<?> toCollection(String s) throws SQLException {
        return this.toCollection(this.getColIdxByName(s));
    }
    
    @Override
    public SyncProvider getSyncProvider() throws SQLException {
        return this.provider;
    }
    
    @Override
    public void setSyncProvider(String providerID) throws SQLException {
        this.provider = SyncFactory.getInstance(providerID);
        this.rowSetReader = this.provider.getRowSetReader();
        this.rowSetWriter = this.provider.getRowSetWriter();
    }
    
    @Override
    public void execute() throws SQLException {
        this.execute(null);
    }
    
    @Override
    public boolean next() throws SQLException {
        if (this.cursorPos < 0 || this.cursorPos >= this.numRows + 1) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        int internalNext = this.internalNext();
        this.notifyCursorMoved();
        return internalNext;
    }
    
    protected boolean internalNext() throws SQLException {
        boolean n = false;
        do {
            if (this.cursorPos < this.numRows) {
                ++this.cursorPos;
                n = true;
            }
            else {
                if (this.cursorPos == this.numRows) {
                    ++this.cursorPos;
                    n = false;
                    break;
                }
                continue;
            }
        } while (!this.getShowDeleted() && this.rowDeleted());
        if (n != 0) {
            ++this.absolutePos;
        }
        else {
            this.absolutePos = 0;
        }
        return n;
    }
    
    @Override
    public void close() throws SQLException {
        this.cursorPos = 0;
        this.absolutePos = 0;
        this.numRows = 0;
        this.numDeleted = 0;
        this.initProperties();
        this.rvh.clear();
    }
    
    @Override
    public boolean wasNull() throws SQLException {
        return this.lastValueNull;
    }
    
    private void setLastValueNull(boolean lastValueNull) {
        this.lastValueNull = lastValueNull;
    }
    
    private void checkIndex(int n) throws SQLException {
        if (n < 1 || n > this.RowSetMD.getColumnCount()) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcol").toString());
        }
        return;
    }
    
    private void checkCursor() throws SQLException {
        if (this.isAfterLast() || this.isBeforeFirst()) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        return;
    }
    
    private int getColIdxByName(String s) throws SQLException {
        this.RowSetMD = (RowSetMetaDataImpl)this.getMetaData();
        int columnCount = this.RowSetMD.getColumnCount();
        int i = 1;
        while (i <= columnCount) {
            String columnName = this.RowSetMD.getColumnName(i);
            if (columnName != null && s.equalsIgnoreCase(columnName)) {
                return i;
            }
            ++i;
        }
        throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalcolnm").toString());
    }
    
    protected BaseRow getCurrentRow() {
        if (this.onInsertRow) {
            return this.insertRow;
        }
        return (BaseRow)(BaseRow)this.rvh.get(this.cursorPos - 1);
    }
    
    protected void removeCurrentRow() {
        ((Row)this.getCurrentRow()).setDeleted();
        this.rvh.remove(this.cursorPos - 1);
        --this.numRows;
    }
    
    @Override
    public String getString(int n) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(n);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        return columnObject.toString();
    }
    
    @Override
    public boolean getBoolean(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return false;
        }
        if ((columnObject instanceof Boolean)) {
            return (boolean)columnObject;
        }
        try {
            return Double.compare(Double.parseDouble(columnObject.toString()), 0.0) != 0;
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.boolfail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Override
    public byte getByte(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return 0;
        }
        try {
            return (byte)Byte.valueOf(columnObject.toString());
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.bytefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Override
    public short getShort(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return 0;
        }
        try {
            return (short)Short.valueOf(columnObject.toString().trim());
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.shortfail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Override
    public int getInt(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return 0;
        }
        try {
            return (int)Integer.valueOf(columnObject.toString().trim());
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.intfail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Override
    public long getLong(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return 0L;
        }
        try {
            return (long)Long.valueOf(columnObject.toString().trim());
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.longfail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Override
    public float getFloat(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return 0.0f;
        }
        try {
            return (float)new Float(columnObject.toString());
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.floatfail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Override
    public double getDouble(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return 0.0;
        }
        try {
            return (double)new Double(columnObject.toString().trim());
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.doublefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Deprecated
    @Override
    public BigDecimal getBigDecimal(int n, int scale) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.setLastValueNull(false);
        if (this.getCurrentRow().getColumnObject(n) == null) {
            this.setLastValueNull(true);
            return new BigDecimal(0);
        }
        return this.getBigDecimal(n).setScale(scale);
    }
    
    @Override
    public byte[] getBytes(int columnIndex) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        if (!this.isBinary(this.RowSetMD.getColumnType(columnIndex))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        return (byte[])(byte[])this.getCurrentRow().getColumnObject(columnIndex);
    }
    
    @Override
    public Date getDate(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        switch (this.RowSetMD.getColumnType(i)) {
            case 91: {
                return new Date(((Date)columnObject).getTime());
            }
            case 93: {
                return new Date(((Timestamp)columnObject).getTime());
            }
            case -1:
            case 1:
            case 12: {
                try {
                    return (Date)(Date)DateFormat.getDateInstance().parse(columnObject.toString());
                }
                catch (ParseException ex) {
                    throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.datefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
                }
            }
            default: {
                throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.datefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
            }
        }
    }
    
    @Override
    public Time getTime(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        switch (this.RowSetMD.getColumnType(i)) {
            case 92: {
                return (Time)columnObject;
            }
            case 93: {
                return new Time(((Timestamp)columnObject).getTime());
            }
            case -1:
            case 1:
            case 12: {
                try {
                    return (Time)(Time)DateFormat.getTimeInstance().parse(columnObject.toString());
                }
                catch (ParseException ex) {
                    throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.timefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
                }
            }
            default: {
                throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.timefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
            }
        }
    }
    
    @Override
    public Timestamp getTimestamp(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        switch (this.RowSetMD.getColumnType(i)) {
            case 93: {
                return (Timestamp)columnObject;
            }
            case 92: {
                return new Timestamp(((Time)columnObject).getTime());
            }
            case 91: {
                return new Timestamp(((Date)columnObject).getTime());
            }
            case -1:
            case 1:
            case 12: {
                try {
                    return (Timestamp)(Timestamp)DateFormat.getTimeInstance().parse(columnObject.toString());
                }
                catch (ParseException ex) {
                    throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.timefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
                }
            }
            default: {
                throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.timefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
            }
        }
    }
    
    @Override
    public InputStream getAsciiStream(int columnIndex) throws SQLException {
        this.asciiStream = null;
        this.checkIndex(columnIndex);
        this.checkCursor();
        Object columnObject = this.getCurrentRow().getColumnObject(columnIndex);
        if (columnObject == null) {
            this.lastValueNull = true;
            return null;
        }
        try {
            if (this.isString(this.RowSetMD.getColumnType(columnIndex))) {
                this.asciiStream = new ByteArrayInputStream(((String)columnObject).getBytes("ASCII"));
            }
            else {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
            }
        }
        catch (UnsupportedEncodingException ex) {
            throw new SQLException(ex.getMessage());
        }
        return this.asciiStream;
    }
    
    @Deprecated
    @Override
    public InputStream getUnicodeStream(int n) throws SQLException {
        this.unicodeStream = null;
        this.checkIndex(n);
        this.checkCursor();
        if (!this.isBinary(this.RowSetMD.getColumnType(n)) && !this.isString(this.RowSetMD.getColumnType(n))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        Object columnObject = this.getCurrentRow().getColumnObject(n);
        if (columnObject == null) {
            this.lastValueNull = true;
            return null;
        }
        return this.unicodeStream = new StringBufferInputStream(columnObject.toString());
    }
    
    @Override
    public InputStream getBinaryStream(int columnIndex) throws SQLException {
        this.binaryStream = null;
        this.checkIndex(columnIndex);
        this.checkCursor();
        if (!this.isBinary(this.RowSetMD.getColumnType(columnIndex))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        Object columnObject = this.getCurrentRow().getColumnObject(columnIndex);
        if (columnObject == null) {
            this.lastValueNull = true;
            return null;
        }
        return this.binaryStream = new ByteArrayInputStream((byte[])(byte[])columnObject);
    }
    
    @Override
    public String getString(String s) throws SQLException {
        return this.getString(this.getColIdxByName(s));
    }
    
    @Override
    public boolean getBoolean(String s) throws SQLException {
        return this.getBoolean(this.getColIdxByName(s));
    }
    
    @Override
    public byte getByte(String s) throws SQLException {
        return this.getByte(this.getColIdxByName(s));
    }
    
    @Override
    public short getShort(String s) throws SQLException {
        return this.getShort(this.getColIdxByName(s));
    }
    
    @Override
    public int getInt(String s) throws SQLException {
        return this.getInt(this.getColIdxByName(s));
    }
    
    @Override
    public long getLong(String s) throws SQLException {
        return this.getLong(this.getColIdxByName(s));
    }
    
    @Override
    public float getFloat(String s) throws SQLException {
        return this.getFloat(this.getColIdxByName(s));
    }
    
    @Override
    public double getDouble(String s) throws SQLException {
        return this.getDouble(this.getColIdxByName(s));
    }
    
    @Deprecated
    @Override
    public BigDecimal getBigDecimal(String s, int n) throws SQLException {
        return this.getBigDecimal(this.getColIdxByName(s), n);
    }
    
    @Override
    public byte[] getBytes(String s) throws SQLException {
        return this.getBytes(this.getColIdxByName(s));
    }
    
    @Override
    public Date getDate(String s) throws SQLException {
        return this.getDate(this.getColIdxByName(s));
    }
    
    @Override
    public Time getTime(String s) throws SQLException {
        return this.getTime(this.getColIdxByName(s));
    }
    
    @Override
    public Timestamp getTimestamp(String s) throws SQLException {
        return this.getTimestamp(this.getColIdxByName(s));
    }
    
    @Override
    public InputStream getAsciiStream(String s) throws SQLException {
        return this.getAsciiStream(this.getColIdxByName(s));
    }
    
    @Deprecated
    @Override
    public InputStream getUnicodeStream(String s) throws SQLException {
        return this.getUnicodeStream(this.getColIdxByName(s));
    }
    
    @Override
    public InputStream getBinaryStream(String s) throws SQLException {
        return this.getBinaryStream(this.getColIdxByName(s));
    }
    
    @Override
    public SQLWarning getWarnings() {
        return this.sqlwarn;
    }
    
    @Override
    public void clearWarnings() {
        this.sqlwarn = null;
    }
    
    @Override
    public String getCursorName() throws SQLException {
        throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.posupdate").toString());
    }
    
    @Override
    public ResultSetMetaData getMetaData() throws SQLException {
        return this.RowSetMD;
    }
    
    @Override
    public Object getObject(int n) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(n);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        if ((columnObject instanceof Struct)) {
            Struct struct = (Struct)columnObject;
            Map<String, Class<?>> typeMap = this.getTypeMap();
            Class<Object> clazz = (Class)typeMap.get(struct.getSQLTypeName());
            if (clazz != null) {
                SQLData sqlData;
                try {
                    sqlData = (SQLData)ReflectUtil.newInstance(clazz);
                }
                catch (Exception cause) {
                    throw new SQLException("Unable to Instantiate: ", cause);
                }
                sqlData.readSQL(new SQLInputImpl(struct.getAttributes(typeMap), typeMap), struct.getSQLTypeName());
                return sqlData;
            }
        }
        return columnObject;
    }
    
    @Override
    public Object getObject(String s) throws SQLException {
        return this.getObject(this.getColIdxByName(s));
    }
    
    @Override
    public int findColumn(String s) throws SQLException {
        return this.getColIdxByName(s);
    }
    
    @Override
    public Reader getCharacterStream(int n) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        if (this.isBinary(this.RowSetMD.getColumnType(n))) {
            Object columnObject2 = this.getCurrentRow().getColumnObject(n);
            if (columnObject2 == null) {
                this.lastValueNull = true;
                return null;
            }
            this.charStream = new InputStreamReader(new ByteArrayInputStream((byte[])(byte[])columnObject2));
        }
        else if (this.isString(this.RowSetMD.getColumnType(n))) {
            Object columnObject = this.getCurrentRow().getColumnObject(n);
            if (columnObject == null) {
                this.lastValueNull = true;
                return null;
            }
            this.charStream = new StringReader(columnObject.toString());
        }
        else {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        return this.charStream;
    }
    
    @Override
    public Reader getCharacterStream(String s) throws SQLException {
        return this.getCharacterStream(this.getColIdxByName(s));
    }
    
    @Override
    public BigDecimal getBigDecimal(int i) throws SQLException {
        this.checkIndex(i);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(i);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        try {
            return new BigDecimal(columnObject.toString().trim());
        }
        catch (NumberFormatException ex) {
            throw new SQLException(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.doublefail").toString(), new Object[] { columnObject.toString().trim(), Integer.valueOf(i) }));
        }
    }
    
    @Override
    public BigDecimal getBigDecimal(String s) throws SQLException {
        return this.getBigDecimal(this.getColIdxByName(s));
    }
    
    @Override
    public int size() {
        return this.numRows;
    }
    
    @Override
    public boolean isBeforeFirst() throws SQLException {
        return this.cursorPos == 0 && this.numRows > 0;
    }
    
    @Override
    public boolean isAfterLast() throws SQLException {
        return this.cursorPos == this.numRows + 1 && this.numRows > 0;
    }
    
    @Override
    public boolean isFirst() throws SQLException {
        int cursorPos = this.cursorPos;
        int absolutePos = this.absolutePos;
        this.internalFirst();
        if (this.cursorPos == cursorPos) {
            return true;
        }
        this.cursorPos = cursorPos;
        this.absolutePos = absolutePos;
        return false;
    }
    
    @Override
    public boolean isLast() throws SQLException {
        int cursorPos = this.cursorPos;
        int absolutePos = this.absolutePos;
        int showDeleted = this.getShowDeleted();
        this.setShowDeleted(true);
        this.internalLast();
        if (this.cursorPos == cursorPos) {
            this.setShowDeleted((boolean)showDeleted);
            return true;
        }
        this.setShowDeleted((boolean)showDeleted);
        this.cursorPos = cursorPos;
        this.absolutePos = absolutePos;
        return false;
    }
    
    @Override
    public void beforeFirst() throws SQLException {
        if (this.getType() == 1003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.beforefirst").toString());
        }
        this.cursorPos = 0;
        this.absolutePos = 0;
        this.notifyCursorMoved();
        return;
    }
    
    @Override
    public void afterLast() throws SQLException {
        if (this.numRows > 0) {
            this.cursorPos = this.numRows + 1;
            this.absolutePos = 0;
            this.notifyCursorMoved();
        }
    }
    
    @Override
    public boolean first() throws SQLException {
        if (this.getType() == 1003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.first").toString());
        }
        int internalFirst = this.internalFirst();
        this.notifyCursorMoved();
        return internalFirst;
    }
    
    protected boolean internalFirst() throws SQLException {
        boolean n = false;
        if (this.numRows > 0) {
            this.cursorPos = 1;
            n = (this.getShowDeleted() || !this.rowDeleted() || this.internalNext());
        }
        if (n != 0) {
            this.absolutePos = 1;
        }
        else {
            this.absolutePos = 0;
        }
        return n;
    }
    
    @Override
    public boolean last() throws SQLException {
        if (this.getType() == 1003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.last").toString());
        }
        int internalLast = this.internalLast();
        this.notifyCursorMoved();
        return internalLast;
    }
    
    protected boolean internalLast() throws SQLException {
        boolean n = false;
        if (this.numRows > 0) {
            this.cursorPos = this.numRows;
            n = (this.getShowDeleted() || !this.rowDeleted() || this.internalPrevious());
        }
        if (n != 0) {
            this.absolutePos = this.numRows - this.numDeleted;
        }
        else {
            this.absolutePos = 0;
        }
        return n;
    }
    
    @Override
    public int getRow() throws SQLException {
        if (this.numRows > 0 && this.cursorPos > 0 && this.cursorPos < this.numRows + 1 && !this.getShowDeleted() && !this.rowDeleted()) {
            return this.absolutePos;
        }
        if (this.getShowDeleted()) {
            return this.cursorPos;
        }
        return 0;
    }
    
    @Override
    public boolean absolute(int n) throws SQLException {
        if (n == 0 || this.getType() == 1003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.absolute").toString());
        }
        if (n > 0) {
            if (n > this.numRows) {
                this.afterLast();
                return false;
            }
            if (this.absolutePos <= 0) {
                this.internalFirst();
            }
        }
        else {
            if (this.cursorPos + n < 0) {
                this.beforeFirst();
                return false;
            }
            if (this.absolutePos >= 0) {
                this.internalLast();
            }
        }
        while (this.absolutePos != n && ((this.absolutePos >= n) ? this.internalPrevious() : this.internalNext())) {}
        this.notifyCursorMoved();
        return !this.isAfterLast() && !this.isBeforeFirst();
    }
    
    @Override
    public boolean relative(int i) throws SQLException {
        if (this.numRows == 0 || this.isBeforeFirst() || this.isAfterLast() || this.getType() == 1003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.relative").toString());
        }
        if (i == 0) {
            return true;
        }
        if (i > 0) {
            if (this.cursorPos + i > this.numRows) {
                this.afterLast();
            }
            else {
                for (int n = 0; n < i && this.internalNext(); ++n) {}
            }
        }
        else if (this.cursorPos + i < 0) {
            this.beforeFirst();
        }
        else {
            while (i < 0) {
                if (!this.internalPrevious()) {
                    break;
                }
                ++i;
            }
        }
        this.notifyCursorMoved();
        return !this.isAfterLast() && !this.isBeforeFirst();
    }
    
    @Override
    public boolean previous() throws SQLException {
        if (this.getType() == 1003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.last").toString());
        }
        if (this.cursorPos < 0 || this.cursorPos > this.numRows + 1) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        int internalPrevious = this.internalPrevious();
        this.notifyCursorMoved();
        return internalPrevious;
    }
    
    protected boolean internalPrevious() throws SQLException {
        boolean n = false;
        do {
            if (this.cursorPos > 1) {
                --this.cursorPos;
                n = true;
            }
            else {
                if (this.cursorPos == 1) {
                    --this.cursorPos;
                    n = false;
                    break;
                }
                continue;
            }
        } while (!this.getShowDeleted() && this.rowDeleted());
        if (n != 0) {
            --this.absolutePos;
        }
        else {
            this.absolutePos = 0;
        }
        return n;
    }
    
    @Override
    public boolean rowUpdated() throws SQLException {
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidop").toString());
        }
        return ((Row)this.getCurrentRow()).getUpdated();
    }
    
    @Override
    public boolean columnUpdated(int n) throws SQLException {
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidop").toString());
        }
        return ((Row)this.getCurrentRow()).getColUpdated(n - 1);
    }
    
    @Override
    public boolean columnUpdated(String s) throws SQLException {
        return this.columnUpdated(this.getColIdxByName(s));
    }
    
    @Override
    public boolean rowInserted() throws SQLException {
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidop").toString());
        }
        return ((Row)this.getCurrentRow()).getInserted();
    }
    
    @Override
    public boolean rowDeleted() throws SQLException {
        if (this.isAfterLast() || this.isBeforeFirst() || this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        return ((Row)this.getCurrentRow()).getDeleted();
    }
    
    private boolean isNumeric(int n) {
        switch (n) {
            case -7:
            case -6:
            case -5:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
            case 8: {
                return true;
            }
            default: {
                return false;
            }
        }
    }
    
    private boolean isString(int n) {
        switch (n) {
            case -1:
            case 1:
            case 12: {
                return true;
            }
            default: {
                return false;
            }
        }
    }
    
    private boolean isBinary(int n) {
        switch (n) {
            case -4:
            case -3:
            case -2: {
                return true;
            }
            default: {
                return false;
            }
        }
    }
    
    private boolean isTemporal(int n) {
        switch (n) {
            case 91:
            case 92:
            case 93: {
                return true;
            }
            default: {
                return false;
            }
        }
    }
    
    private boolean isBoolean(int n) {
        switch (n) {
            case -7:
            case 16: {
                return true;
            }
            default: {
                return false;
            }
        }
    }
    
    private Object convertNumeric(Object o, int n, int i) throws SQLException {
        if (n == i) {
            return o;
        }
        if (!this.isNumeric(i) && !this.isString(i)) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString() + i);
        }
        try {
            switch (i) {
                case -7: {
                    return Integer.valueOf(o.toString().trim()).equals(Integer.valueOf(0)) ? Boolean.valueOf(false) : Boolean.valueOf(true);
                }
                case -6: {
                    return Byte.valueOf(o.toString().trim());
                }
                case 5: {
                    return Short.valueOf(o.toString().trim());
                }
                case 4: {
                    return Integer.valueOf(o.toString().trim());
                }
                case -5: {
                    return Long.valueOf(o.toString().trim());
                }
                case 2:
                case 3: {
                    return new BigDecimal(o.toString().trim());
                }
                case 6:
                case 7: {
                    return new Float(o.toString().trim());
                }
                case 8: {
                    return new Double(o.toString().trim());
                }
                case -1:
                case 1:
                case 12: {
                    return o.toString();
                }
                default: {
                    throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString() + i);
                }
            }
        }
        catch (NumberFormatException ex) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString() + i);
        }
    }
    
    private Object convertTemporal(Object o, int n, int n2) throws SQLException {
        if (n == n2) {
            return o;
        }
        if (this.isNumeric(n2) || (!this.isString(n2) && !this.isTemporal(n2))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        try {
            switch (n2) {
                case 91: {
                    if (n == 93) {
                        return new Date(((Timestamp)o).getTime());
                    }
                    throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
                }
                case 93: {
                    if (n == 92) {
                        return new Timestamp(((Time)o).getTime());
                    }
                    return new Timestamp(((Date)o).getTime());
                }
                case 92: {
                    if (n == 93) {
                        return new Time(((Timestamp)o).getTime());
                    }
                    throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
                }
                case -1:
                case 1:
                case 12: {
                    return o.toString();
                }
                default: {
                    throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
                }
            }
        }
        catch (NumberFormatException ex) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
    }
    
    private Object convertBoolean(Object o, int n, int n2) throws SQLException {
        if (n == n2) {
            return o;
        }
        if (this.isNumeric(n2) || (!this.isString(n2) && !this.isBoolean(n2))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        try {
            switch (n2) {
                case -7: {
                    return Integer.valueOf(o.toString().trim()).equals(Integer.valueOf(0)) ? Boolean.valueOf(false) : Boolean.valueOf(true);
                }
                case 16: {
                    return Boolean.valueOf(o.toString().trim());
                }
                default: {
                    throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString() + n2);
                }
            }
        }
        catch (NumberFormatException ex) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString() + n2);
        }
    }
    
    @Override
    public void updateNull(int n) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(n, null);
    }
    
    @Override
    public void updateBoolean(int columnIndex, boolean b) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertBoolean(Boolean.valueOf(b), -7, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateByte(int columnIndex, byte b) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertNumeric(Byte.valueOf(b), -6, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateShort(int columnIndex, short s) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertNumeric(Short.valueOf(s), 5, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateInt(int columnIndex, int i) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertNumeric(Integer.valueOf(i), 4, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateLong(int columnIndex, long l) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertNumeric(Long.valueOf(l), -5, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateFloat(int columnIndex, float f) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertNumeric(Float.valueOf(f), 7, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateDouble(int columnIndex, double d) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertNumeric(Double.valueOf(d), 8, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateBigDecimal(int columnIndex, BigDecimal bigDecimal) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertNumeric(bigDecimal, 2, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateString(int n, String s) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(n, s);
    }
    
    @Override
    public void updateBytes(int columnIndex, byte[] array) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        if (!this.isBinary(this.RowSetMD.getColumnType(columnIndex))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        this.getCurrentRow().setColumnObject(columnIndex, array);
        return;
    }
    
    @Override
    public void updateDate(int columnIndex, Date date) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertTemporal(date, 91, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateTime(int columnIndex, Time time) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertTemporal(time, 92, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateTimestamp(int columnIndex, Timestamp timestamp) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(columnIndex, this.convertTemporal(timestamp, 93, this.RowSetMD.getColumnType(columnIndex)));
    }
    
    @Override
    public void updateAsciiStream(int n, InputStream inputStream, int n2) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        if (!this.isString(this.RowSetMD.getColumnType(n)) && !this.isBinary(this.RowSetMD.getColumnType(n))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        byte[] array = new byte[n2];
        try {
            int i = 0;
            do {
                i += inputStream.read(array, i, n2 - i);
            } while (i != n2);
        }
        catch (IOException ex) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.asciistream").toString());
        }
        this.getCurrentRow().setColumnObject(n, new String(array));
        return;
    }
    
    @Override
    public void updateBinaryStream(int columnIndex, InputStream inputStream, int n) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        if (!this.isBinary(this.RowSetMD.getColumnType(columnIndex))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        byte[] b = new byte[n];
        try {
            int i = 0;
            do {
                i += inputStream.read(b, i, n - i);
            } while (i != -1);
        }
        catch (IOException ex) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.binstream").toString());
        }
        this.getCurrentRow().setColumnObject(columnIndex, b);
        return;
    }
    
    @Override
    public void updateCharacterStream(int n, Reader reader, int n2) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        if (!this.isString(this.RowSetMD.getColumnType(n)) && !this.isBinary(this.RowSetMD.getColumnType(n))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        char[] value = new char[n2];
        try {
            int i = 0;
            do {
                i += reader.read(value, i, n2 - i);
            } while (i != n2);
        }
        catch (IOException ex) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.binstream").toString());
        }
        this.getCurrentRow().setColumnObject(n, new String(value));
        return;
    }
    
    @Override
    public void updateObject(int columnIndex, Object o, int scale) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        int columnType = this.RowSetMD.getColumnType(columnIndex);
        if (columnType == 3 || columnType == 2) {
            ((BigDecimal)o).setScale(scale);
        }
        this.getCurrentRow().setColumnObject(columnIndex, o);
    }
    
    @Override
    public void updateObject(int n, Object o) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(n, o);
    }
    
    @Override
    public void updateNull(String s) throws SQLException {
        this.updateNull(this.getColIdxByName(s));
    }
    
    @Override
    public void updateBoolean(String s, boolean b) throws SQLException {
        this.updateBoolean(this.getColIdxByName(s), b);
    }
    
    @Override
    public void updateByte(String s, byte b) throws SQLException {
        this.updateByte(this.getColIdxByName(s), b);
    }
    
    @Override
    public void updateShort(String s, short n) throws SQLException {
        this.updateShort(this.getColIdxByName(s), n);
    }
    
    @Override
    public void updateInt(String s, int n) throws SQLException {
        this.updateInt(this.getColIdxByName(s), n);
    }
    
    @Override
    public void updateLong(String s, long n) throws SQLException {
        this.updateLong(this.getColIdxByName(s), n);
    }
    
    @Override
    public void updateFloat(String s, float n) throws SQLException {
        this.updateFloat(this.getColIdxByName(s), n);
    }
    
    @Override
    public void updateDouble(String s, double n) throws SQLException {
        this.updateDouble(this.getColIdxByName(s), n);
    }
    
    @Override
    public void updateBigDecimal(String s, BigDecimal bigDecimal) throws SQLException {
        this.updateBigDecimal(this.getColIdxByName(s), bigDecimal);
    }
    
    @Override
    public void updateString(String s, String s2) throws SQLException {
        this.updateString(this.getColIdxByName(s), s2);
    }
    
    @Override
    public void updateBytes(String s, byte[] array) throws SQLException {
        this.updateBytes(this.getColIdxByName(s), array);
    }
    
    @Override
    public void updateDate(String s, Date date) throws SQLException {
        this.updateDate(this.getColIdxByName(s), date);
    }
    
    @Override
    public void updateTime(String s, Time time) throws SQLException {
        this.updateTime(this.getColIdxByName(s), time);
    }
    
    @Override
    public void updateTimestamp(String s, Timestamp timestamp) throws SQLException {
        this.updateTimestamp(this.getColIdxByName(s), timestamp);
    }
    
    @Override
    public void updateAsciiStream(String s, InputStream inputStream, int n) throws SQLException {
        this.updateAsciiStream(this.getColIdxByName(s), inputStream, n);
    }
    
    @Override
    public void updateBinaryStream(String s, InputStream inputStream, int n) throws SQLException {
        this.updateBinaryStream(this.getColIdxByName(s), inputStream, n);
    }
    
    @Override
    public void updateCharacterStream(String s, Reader reader, int n) throws SQLException {
        this.updateCharacterStream(this.getColIdxByName(s), reader, n);
    }
    
    @Override
    public void updateObject(String s, Object o, int n) throws SQLException {
        this.updateObject(this.getColIdxByName(s), o, n);
    }
    
    @Override
    public void updateObject(String s, Object o) throws SQLException {
        this.updateObject(this.getColIdxByName(s), o);
    }
    
    @Override
    public void insertRow() throws SQLException {
        if (!this.onInsertRow || !this.insertRow.isCompleteRow(this.RowSetMD)) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.failedins").toString());
        }
        Object[] params = this.getParams();
        for (int i = 0; i < params.length; ++i) {
            this.insertRow.setColumnObject(i + 1, params[i]);
        }
        Row element = new Row(this.RowSetMD.getColumnCount(), this.insertRow.getOrigRow());
        element.setInserted();
        int index;
        if (this.currentRow >= this.numRows || this.currentRow < 0) {
            index = this.numRows;
        }
        else {
            index = this.currentRow;
        }
        this.rvh.add(index, element);
        ++this.numRows;
        this.notifyRowChanged();
        return;
    }
    
    @Override
    public void updateRow() throws SQLException {
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.updateins").toString());
        }
        ((Row)this.getCurrentRow()).setUpdated();
        this.notifyRowChanged();
        return;
    }
    
    @Override
    public void deleteRow() throws SQLException {
        this.checkCursor();
        ((Row)this.getCurrentRow()).setDeleted();
        ++this.numDeleted;
        this.notifyRowChanged();
    }
    
    @Override
    public void refreshRow() throws SQLException {
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        ((Row)this.getCurrentRow()).clearUpdated();
        return;
    }
    
    @Override
    public void cancelRowUpdates() throws SQLException {
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcp").toString());
        }
        Row row = (Row)this.getCurrentRow();
        if (row.getUpdated()) {
            row.clearUpdated();
            this.notifyRowChanged();
        }
        return;
    }
    
    @Override
    public void moveToInsertRow() throws SQLException {
        if (this.getConcurrency() == 1007) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.movetoins").toString());
        }
        if (this.insertRow == null) {
            if (this.RowSetMD == null) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.movetoins1").toString());
            }
            int columnCount = this.RowSetMD.getColumnCount();
            if (columnCount > 0) {
                this.insertRow = new InsertRow(columnCount);
            }
            else {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.movetoins2").toString());
            }
        }
        this.onInsertRow = true;
        this.currentRow = this.cursorPos;
        this.cursorPos = -1;
        this.insertRow.initInsertRow();
        return;
    }
    
    @Override
    public void moveToCurrentRow() throws SQLException {
        if (!this.onInsertRow) {
            return;
        }
        this.cursorPos = this.currentRow;
        this.onInsertRow = false;
        return;
    }
    
    @Override
    public Statement getStatement() throws SQLException {
        return null;
    }
    
    @Override
    public Object getObject(int n, Map<String, Class<?>> map) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(n);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        if ((columnObject instanceof Struct)) {
            Struct struct = (Struct)columnObject;
            Class<Object> clazz = (Class)map.get(struct.getSQLTypeName());
            if (clazz != null) {
                SQLData sqlData;
                try {
                    sqlData = (SQLData)ReflectUtil.newInstance(clazz);
                }
                catch (Exception cause) {
                    throw new SQLException("Unable to Instantiate: ", cause);
                }
                sqlData.readSQL(new SQLInputImpl(struct.getAttributes(map), map), struct.getSQLTypeName());
                return sqlData;
            }
        }
        return columnObject;
    }
    
    @Override
    public Ref getRef(int columnIndex) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        if (this.RowSetMD.getColumnType(columnIndex) != 2006) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        this.setLastValueNull(false);
        Ref ref = (Ref)(Ref)this.getCurrentRow().getColumnObject(columnIndex);
        if (ref == null) {
            this.setLastValueNull(true);
            return null;
        }
        return ref;
    }
    
    @Override
    public Blob getBlob(int n) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        if (this.RowSetMD.getColumnType(n) != 2004) {
            System.out.println(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.type").toString(), new Object[] { Integer.valueOf(this.RowSetMD.getColumnType(n)) }));
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        this.setLastValueNull(false);
        Blob blob = (Blob)(Blob)this.getCurrentRow().getColumnObject(n);
        if (blob == null) {
            this.setLastValueNull(true);
            return null;
        }
        return blob;
    }
    
    @Override
    public Clob getClob(int n) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        if (this.RowSetMD.getColumnType(n) != 2005) {
            System.out.println(MessageFormat.format(this.resBundle.handleGetObject("cachedrowsetimpl.type").toString(), new Object[] { Integer.valueOf(this.RowSetMD.getColumnType(n)) }));
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        this.setLastValueNull(false);
        Clob clob = (Clob)(Clob)this.getCurrentRow().getColumnObject(n);
        if (clob == null) {
            this.setLastValueNull(true);
            return null;
        }
        return clob;
    }
    
    @Override
    public Array getArray(int columnIndex) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        if (this.RowSetMD.getColumnType(columnIndex) != 2003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        this.setLastValueNull(false);
        Array array = (Array)(Array)this.getCurrentRow().getColumnObject(columnIndex);
        if (array == null) {
            this.setLastValueNull(true);
            return null;
        }
        return array;
    }
    
    @Override
    public Object getObject(String s, Map<String, Class<?>> map) throws SQLException {
        return this.getObject(this.getColIdxByName(s), map);
    }
    
    @Override
    public Ref getRef(String s) throws SQLException {
        return this.getRef(this.getColIdxByName(s));
    }
    
    @Override
    public Blob getBlob(String s) throws SQLException {
        return this.getBlob(this.getColIdxByName(s));
    }
    
    @Override
    public Clob getClob(String s) throws SQLException {
        return this.getClob(this.getColIdxByName(s));
    }
    
    @Override
    public Array getArray(String s) throws SQLException {
        return this.getArray(this.getColIdxByName(s));
    }
    
    @Override
    public Date getDate(int columnIndex, Calendar calendar) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(columnIndex);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        Object convertTemporal = this.convertTemporal(columnObject, this.RowSetMD.getColumnType(columnIndex), 91);
        Calendar instance = Calendar.getInstance();
        instance.setTime((java.util.Date)convertTemporal);
        calendar.set(1, instance.get(1));
        calendar.set(2, instance.get(2));
        calendar.set(5, instance.get(5));
        return new Date(calendar.getTime().getTime());
    }
    
    @Override
    public Date getDate(String s, Calendar calendar) throws SQLException {
        return this.getDate(this.getColIdxByName(s), calendar);
    }
    
    @Override
    public Time getTime(int columnIndex, Calendar calendar) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(columnIndex);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        Object convertTemporal = this.convertTemporal(columnObject, this.RowSetMD.getColumnType(columnIndex), 92);
        Calendar instance = Calendar.getInstance();
        instance.setTime((java.util.Date)convertTemporal);
        calendar.set(11, instance.get(11));
        calendar.set(12, instance.get(12));
        calendar.set(13, instance.get(13));
        return new Time(calendar.getTime().getTime());
    }
    
    @Override
    public Time getTime(String s, Calendar calendar) throws SQLException {
        return this.getTime(this.getColIdxByName(s), calendar);
    }
    
    @Override
    public Timestamp getTimestamp(int columnIndex, Calendar calendar) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        this.setLastValueNull(false);
        Object columnObject = this.getCurrentRow().getColumnObject(columnIndex);
        if (columnObject == null) {
            this.setLastValueNull(true);
            return null;
        }
        Object convertTemporal = this.convertTemporal(columnObject, this.RowSetMD.getColumnType(columnIndex), 93);
        Calendar instance = Calendar.getInstance();
        instance.setTime((java.util.Date)convertTemporal);
        calendar.set(1, instance.get(1));
        calendar.set(2, instance.get(2));
        calendar.set(5, instance.get(5));
        calendar.set(11, instance.get(11));
        calendar.set(12, instance.get(12));
        calendar.set(13, instance.get(13));
        return new Timestamp(calendar.getTime().getTime());
    }
    
    @Override
    public Timestamp getTimestamp(String s, Calendar calendar) throws SQLException {
        return this.getTimestamp(this.getColIdxByName(s), calendar);
    }
    
    @Override
    public Connection getConnection() throws SQLException {
        return this.conn;
    }
    
    @Override
    public void setMetaData(RowSetMetaData rowSetMetaData) throws SQLException {
        this.RowSetMD = (RowSetMetaDataImpl)rowSetMetaData;
    }
    
    @Override
    public ResultSet getOriginal() throws SQLException {
        CachedRowSetImpl cachedRowSetImpl = new CachedRowSetImpl();
        cachedRowSetImpl.RowSetMD = this.RowSetMD;
        cachedRowSetImpl.numRows = this.numRows;
        cachedRowSetImpl.cursorPos = 0;
        int columnCount = this.RowSetMD.getColumnCount();
        Iterator<Object> iterator = this.rvh.iterator();
        while (iterator.hasNext()) {
            cachedRowSetImpl.rvh.add(new Row(columnCount, ((Row)iterator.next()).getOrigRow()));
        }
        return cachedRowSetImpl;
    }
    
    @Override
    public ResultSet getOriginalRow() throws SQLException {
        CachedRowSetImpl cachedRowSetImpl = new CachedRowSetImpl();
        cachedRowSetImpl.RowSetMD = this.RowSetMD;
        cachedRowSetImpl.numRows = 1;
        cachedRowSetImpl.cursorPos = 0;
        cachedRowSetImpl.setTypeMap(this.getTypeMap());
        cachedRowSetImpl.rvh.add(new Row(this.RowSetMD.getColumnCount(), this.getCurrentRow().getOrigRow()));
        return cachedRowSetImpl;
    }
    
    @Override
    public void setOriginalRow() throws SQLException {
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidop").toString());
        }
        Row row = (Row)this.getCurrentRow();
        this.makeRowOriginal(row);
        if (row.getDeleted()) {
            this.removeCurrentRow();
        }
        return;
    }
    
    private void makeRowOriginal(Row row) {
        if (row.getInserted()) {
            row.clearInserted();
        }
        if (row.getUpdated()) {
            row.moveCurrentToOrig();
        }
    }
    
    public void setOriginal() throws SQLException {
        Iterator<Object> iterator = this.rvh.iterator();
        while (iterator.hasNext()) {
            Row row = (Row)iterator.next();
            this.makeRowOriginal(row);
            if (row.getDeleted()) {
                iterator.remove();
                --this.numRows;
            }
            else {
                continue;
            }
        }
        this.numDeleted = 0;
        this.notifyRowSetChanged();
    }
    
    @Override
    public String getTableName() throws SQLException {
        return this.tableName;
    }
    
    @Override
    public void setTableName(String tableName) throws SQLException {
        if (tableName == null) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.tablename").toString());
        }
        this.tableName = tableName;
        return;
    }
    
    @Override
    public int[] getKeyColumns() throws SQLException {
        int[] keyCols = this.keyCols;
        return (keyCols == null) ? null : Arrays.copyOf(keyCols, keyCols.length);
    }
    
    @Override
    public void setKeyColumns(int[] array) throws SQLException {
        int columnCount = 0;
        if (this.RowSetMD != null) {
            columnCount = this.RowSetMD.getColumnCount();
            if (array.length > columnCount) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.keycols").toString());
            }
        }
        this.keyCols = new int[array.length];
        int i = 0;
        while (i < array.length) {
            if (this.RowSetMD != null && (array[i] <= 0 || array[i] > columnCount)) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidcol").toString() + array[i]);
            }
            this.keyCols[i] = array[i];
            ++i;
        }
    }
    
    @Override
    public void updateRef(int n, Ref ref) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(n, new SerialRef(ref));
    }
    
    @Override
    public void updateRef(String s, Ref ref) throws SQLException {
        this.updateRef(this.getColIdxByName(s), ref);
    }
    
    @Override
    public void updateClob(int n, Clob clob) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        if (this.dbmslocatorsUpdateCopy) {
            this.getCurrentRow().setColumnObject(n, new SerialClob(clob));
            return;
        }
        throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotsupp").toString());
    }
    
    @Override
    public void updateClob(String s, Clob clob) throws SQLException {
        this.updateClob(this.getColIdxByName(s), clob);
    }
    
    @Override
    public void updateBlob(int n, Blob blob) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        if (this.dbmslocatorsUpdateCopy) {
            this.getCurrentRow().setColumnObject(n, new SerialBlob(blob));
            return;
        }
        throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotsupp").toString());
    }
    
    @Override
    public void updateBlob(String s, Blob blob) throws SQLException {
        this.updateBlob(this.getColIdxByName(s), blob);
    }
    
    @Override
    public void updateArray(int n, Array array) throws SQLException {
        this.checkIndex(n);
        this.checkCursor();
        this.getCurrentRow().setColumnObject(n, new SerialArray(array));
    }
    
    @Override
    public void updateArray(String s, Array array) throws SQLException {
        this.updateArray(this.getColIdxByName(s), array);
    }
    
    @Override
    public URL getURL(int columnIndex) throws SQLException {
        this.checkIndex(columnIndex);
        this.checkCursor();
        if (this.RowSetMD.getColumnType(columnIndex) != 70) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.dtypemismt").toString());
        }
        this.setLastValueNull(false);
        URL url = (URL)(URL)this.getCurrentRow().getColumnObject(columnIndex);
        if (url == null) {
            this.setLastValueNull(true);
            return null;
        }
        return url;
    }
    
    @Override
    public URL getURL(String s) throws SQLException {
        return this.getURL(this.getColIdxByName(s));
    }
    
    @Override
    public RowSetWarning getRowSetWarnings() {
        try {
            this.notifyCursorMoved();
        }
        catch (SQLException ex) {}
        return this.rowsetWarning;
    }
    
    private String buildTableName(String trim) throws SQLException {
        String s = "";
        trim = trim.trim();
        if (trim.toLowerCase().startsWith("select")) {
            int index = trim.toLowerCase().indexOf("from");
            if (trim.indexOf(",", index) == -1) {
                String s2 = trim.substring(index + "from".length(), trim.length()).trim();
                int index2 = s2.toLowerCase().indexOf("where");
                if (index2 != -1) {
                    s2 = s2.substring(0, index2).trim();
                }
                s = s2;
            }
        }
        else if (!trim.toLowerCase().startsWith("insert")) {
            trim.toLowerCase().startsWith("update");
        }
        return s;
    }
    
    @Override
    public void commit() throws SQLException {
        this.conn.commit();
    }
    
    @Override
    public void rollback() throws SQLException {
        this.conn.rollback();
    }
    
    @Override
    public void rollback(Savepoint savepoint) throws SQLException {
        this.conn.rollback(savepoint);
    }
    
    @Override
    public void unsetMatchColumn(int[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (array[i] != Integer.parseInt(((Integer)this.iMatchColumns.get(i)).toString())) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.matchcols").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.iMatchColumns.set(j, Integer.valueOf(-1));
        }
    }
    
    @Override
    public void unsetMatchColumn(String[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (!array[i].equals(this.strMatchColumns.get(i))) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.matchcols").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.strMatchColumns.set(j, null);
        }
    }
    
    @Override
    public String[] getMatchColumnNames() throws SQLException {
        String[] anArray = new String[this.strMatchColumns.size()];
        if (this.strMatchColumns.get(0) == null) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.setmatchcols").toString());
        }
        this.strMatchColumns.copyInto(anArray);
        return anArray;
    }
    
    @Override
    public int[] getMatchColumnIndexes() throws SQLException {
        Integer[] anArray = new Integer[this.iMatchColumns.size()];
        int[] array = new int[this.iMatchColumns.size()];
        if ((int)this.iMatchColumns.get(0) == -1) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.setmatchcols").toString());
        }
        this.iMatchColumns.copyInto(anArray);
        for (int i = 0; i < anArray.length; ++i) {
            array[i] = (int)anArray[i];
        }
        return array;
    }
    
    @Override
    public void setMatchColumn(int[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (array[i] < 0) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.matchcols1").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.iMatchColumns.add(j, Integer.valueOf(array[j]));
        }
    }
    
    @Override
    public void setMatchColumn(String[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (array[i] == null || array[i].equals("")) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.matchcols2").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.strMatchColumns.add(j, array[j]);
        }
    }
    
    @Override
    public void setMatchColumn(int i) throws SQLException {
        if (i < 0) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.matchcols1").toString());
        }
        this.iMatchColumns.set(0, Integer.valueOf(i));
        return;
    }
    
    @Override
    public void setMatchColumn(String trim) throws SQLException {
        if (trim == null || (trim = trim.trim()).equals("")) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.matchcols2").toString());
        }
        this.strMatchColumns.set(0, trim);
        return;
    }
    
    @Override
    public void unsetMatchColumn(int i) throws SQLException {
        if (!((Integer)this.iMatchColumns.get(0)).equals(Integer.valueOf(i))) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.unsetmatch").toString());
        }
        if (this.strMatchColumns.get(0) != null) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.unsetmatch1").toString());
        }
        this.iMatchColumns.set(0, Integer.valueOf(-1));
        return;
    }
    
    @Override
    public void unsetMatchColumn(String trim) throws SQLException {
        trim = trim.trim();
        if (!((String)this.strMatchColumns.get(0)).equals(trim)) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.unsetmatch").toString());
        }
        if ((int)this.iMatchColumns.get(0) > 0) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.unsetmatch2").toString());
        }
        this.strMatchColumns.set(0, null);
        return;
    }
    
    @Override
    public void rowSetPopulated(RowSetEvent rowSetEvent, int n) throws SQLException {
        if (n < 0 || n < this.getFetchSize()) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.numrows").toString());
        }
        if (this.size() % n == 0) {
            rowSetEvent = new RowSetEvent(this);
            this.notifyRowSetChanged();
        }
        return;
    }
    
    @Override
    public void populate(ResultSet resultSet, int startPos) throws SQLException {
        Map<String, Class<?>> typeMap = this.getTypeMap();
        this.cursorPos = 0;
        if (this.populatecallcount == 0) {
            if (startPos < 0) {
                throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.startpos").toString());
            }
            if (this.getMaxRows() == 0) {
                resultSet.absolute(startPos);
                while (resultSet.next()) {
                    ++this.totalRows;
                }
                ++this.totalRows;
            }
            this.startPos = startPos;
        }
        ++this.populatecallcount;
        this.resultSet = resultSet;
        if (this.endPos - this.startPos >= this.getMaxRows() && this.getMaxRows() > 0) {
            this.endPos = this.prevEndPos;
            this.pagenotend = false;
            return;
        }
        if ((this.maxRowsreached != this.getMaxRows() || this.maxRowsreached != this.totalRows) && this.pagenotend) {
            this.startPrev = startPos - this.getPageSize();
        }
        if (this.pageSize == 0) {
            this.prevEndPos = this.endPos;
            this.endPos = startPos + this.getMaxRows();
        }
        else {
            this.prevEndPos = this.endPos;
            this.endPos = startPos + this.getPageSize();
        }
        if (startPos == 1) {
            this.resultSet.beforeFirst();
        }
        else {
            this.resultSet.absolute(startPos - 1);
        }
        if (this.pageSize == 0) {
            this.rvh = new Vector(this.getMaxRows());
        }
        else {
            this.rvh = new Vector(this.getPageSize());
        }
        if (resultSet == null) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.populate").toString());
        }
        this.RSMD = resultSet.getMetaData();
        this.initMetaData(this.RowSetMD = new RowSetMetaDataImpl(), this.RSMD);
        this.RSMD = null;
        int columnCount = this.RowSetMD.getColumnCount();
        int maxRows = this.getMaxRows();
        int numRows = 0;
        if (!resultSet.next() && maxRows == 0) {
            this.endPos = this.prevEndPos;
            this.pagenotend = false;
            return;
        }
        resultSet.previous();
        while (resultSet.next()) {
            Row e = new Row(columnCount);
            if (this.pageSize == 0) {
                if (numRows >= maxRows && maxRows > 0) {
                    this.rowsetWarning.setNextException(new SQLException("Populating rows setting has exceeded max row setting"));
                    break;
                }
            }
            else if (numRows >= this.pageSize || (this.maxRowsreached >= maxRows && maxRows > 0)) {
                this.rowsetWarning.setNextException(new SQLException("Populating rows setting has exceeded max row setting"));
                break;
            }
            for (int i = 1; i <= columnCount; ++i) {
                Object val;
                if (typeMap == null) {
                    val = resultSet.getObject(i);
                }
                else {
                    val = resultSet.getObject(i, typeMap);
                }
                if ((val instanceof Struct)) {
                    val = new SerialStruct((Struct)val, typeMap);
                }
                else if ((val instanceof SQLData)) {
                    val = new SerialStruct((SQLData)val, typeMap);
                }
                else if ((val instanceof Blob)) {
                    val = new SerialBlob((Blob)val);
                }
                else if ((val instanceof Clob)) {
                    val = new SerialClob((Clob)val);
                }
                else if ((val instanceof Array)) {
                    val = new SerialArray((Array)val, typeMap);
                }
                e.initColumnObject(i, val);
            }
            ++numRows;
            ++this.maxRowsreached;
            this.rvh.add(e);
        }
        this.numRows = numRows;
        this.notifyRowSetChanged();
        return;
    }
    
    @Override
    public boolean nextPage() throws SQLException {
        if (this.populatecallcount == 0) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.nextpage").toString());
        }
        this.onFirstPage = false;
        if (this.callWithCon) {
            this.crsReader.setStartPosition(this.endPos);
            this.crsReader.readData(this);
            this.resultSet = null;
        }
        else {
            this.populate(this.resultSet, this.endPos);
        }
        return this.pagenotend;
    }
    
    @Override
    public void setPageSize(int pageSize) throws SQLException {
        if (pageSize < 0) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.pagesize").toString());
        }
        if (pageSize > this.getMaxRows() && this.getMaxRows() != 0) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.pagesize1").toString());
        }
        this.pageSize = pageSize;
        return;
    }
    
    @Override
    public int getPageSize() {
        return this.pageSize;
    }
    
    @Override
    public boolean previousPage() throws SQLException {
        int pageSize = this.getPageSize();
        int maxRowsreached = this.maxRowsreached;
        if (this.populatecallcount == 0) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.nextpage").toString());
        }
        if (!this.callWithCon && this.resultSet.getType() == 1003) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.fwdonly").toString());
        }
        this.pagenotend = true;
        if (this.startPrev < this.startPos) {
            this.onFirstPage = true;
            return false;
        }
        if (this.onFirstPage) {
            return false;
        }
        int n = maxRowsreached % pageSize;
        if (n == 0) {
            this.maxRowsreached -= 2 * pageSize;
            if (this.callWithCon) {
                this.crsReader.setStartPosition(this.startPrev);
                this.crsReader.readData(this);
                this.resultSet = null;
            }
            else {
                this.populate(this.resultSet, this.startPrev);
            }
            return true;
        }
        else {
            this.maxRowsreached -= pageSize + n;
            if (this.callWithCon) {
                this.crsReader.setStartPosition(this.startPrev);
                this.crsReader.readData(this);
                this.resultSet = null;
            }
            else {
                this.populate(this.resultSet, this.startPrev);
            }
            return true;
        }
    }
    
    public void setRowInserted(boolean b) throws SQLException {
        this.checkCursor();
        if (this.onInsertRow) {
            throw new SQLException(this.resBundle.handleGetObject("cachedrowsetimpl.invalidop").toString());
        }
        if (b) {
            ((Row)this.getCurrentRow()).setInserted();
        }
        else {
            ((Row)this.getCurrentRow()).clearInserted();
        }
        return;
    }
    
    @Override
    public SQLXML getSQLXML(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public SQLXML getSQLXML(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public RowId getRowId(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public RowId getRowId(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateRowId(int n, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateRowId(String s, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public int getHoldability() throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public boolean isClosed() throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateNString(int n, String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateNString(String s, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateNClob(int n, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateNClob(String s, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public NClob getNClob(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public NClob getNClob(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public <T> T unwrap(Class<T> clazz) throws SQLException {
        return null;
    }
    
    @Override
    public boolean isWrapperFor(Class<?> clazz) throws SQLException {
        return false;
    }
    
    @Override
    public void setSQLXML(int n, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void setSQLXML(String s, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void setRowId(int n, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void setRowId(String s, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void setNCharacterStream(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(String s, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public Reader getNCharacterStream(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public Reader getNCharacterStream(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateSQLXML(int n, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateSQLXML(String s, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public String getNString(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public String getNString(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.opnotysupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(int n, InputStream inputStream, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(String s, InputStream inputStream, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(int n, InputStream inputStream, long n2) throws SQLException {
    }
    
    @Override
    public void updateBinaryStream(int n, InputStream inputStream, long n2) throws SQLException {
    }
    
    @Override
    public void updateCharacterStream(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateCharacterStream(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(String s, InputStream inputStream, long n) throws SQLException {
    }
    
    @Override
    public void updateBinaryStream(String s, InputStream inputStream, long n) throws SQLException {
    }
    
    @Override
    public void updateBinaryStream(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBinaryStream(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateCharacterStream(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(String s, InputStream inputStream) throws SQLException {
    }
    
    @Override
    public void setURL(int n, URL url) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(int n, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNString(int n, String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNString(String s, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNCharacterStream(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNCharacterStream(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTimestamp(String s, Timestamp timestamp, Calendar calendar) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(String s, Clob clob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setDate(String s, Date date) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setDate(String s, Date date, Calendar calendar) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTime(String s, Time time) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTime(String s, Time time, Calendar calendar) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(int n, InputStream inputStream, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(String s, InputStream inputStream, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(String s, Blob blob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setObject(String s, Object o, int n, int n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setObject(String s, Object o, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setObject(String s, Object o) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setAsciiStream(String s, InputStream inputStream, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBinaryStream(String s, InputStream inputStream, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setCharacterStream(String s, Reader reader, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setAsciiStream(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBinaryStream(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBigDecimal(String s, BigDecimal bigDecimal) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setString(String s, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBytes(String s, byte[] array) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTimestamp(String s, Timestamp timestamp) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNull(String s, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNull(String s, int n, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBoolean(String s, boolean b) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setByte(String s, byte b) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setShort(String s, short n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setInt(String s, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setLong(String s, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setFloat(String s, float n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setDouble(String s, double n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("cachedrowsetimpl.featnotsupp").toString());
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
    }
    
    @Override
    public <T> T getObject(int n, Class<T> clazz) throws SQLException {
        throw new SQLFeatureNotSupportedException("Not supported yet.");
    }
    
    @Override
    public <T> T getObject(String s, Class<T> clazz) throws SQLException {
        throw new SQLFeatureNotSupportedException("Not supported yet.");
    }
}
